package com.nisum.demo.blobStorage.pgp;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class PGPService {
    Logger logger = LoggerFactory.getLogger(PGPService.class);

    public void encryptFile(String name) throws IOException {
        ResourceBundle resourceBundle = new PropertyResourceBundle(new FileInputStream("/Users/eali/Projects/azure/myazurefunctionsdemo/src/main/resources/application.properties"));

        InputStream inputStreamSecretKey = new FileInputStream(resourceBundle.getString("gpg.keychain.secret.key"));
        InputStream inputStreamPublicKey = new FileInputStream(resourceBundle.getString("gpg.keychain.public.key"));
        char[] pass = {'n', 'i', 's', 'u', 'm', '1', '2', '3', '4'};

        // Writes data to the output stream
        OutputStream
                outbound = new FileOutputStream(resourceBundle.getString("encrypted.files.directory.path") + name.replaceFirst(".csv",".asc"));
        String inbound= resourceBundle.getString("files.directory.path") + name;

        try {
//            use it when using only public key
//            PGPPublicKey key = PGPUtils.readPublicKey(inputStream);

//            use it to get secret key when using public + private key
//            PGPSecretKey pgpSecretKey = PGPUtils.readSecretKey(inputStream);

//                for encryption
            PGPUtils.encryptAndSignFile(outbound, inbound, inputStreamPublicKey, inputStreamSecretKey, true, true, pass);
            logger.info("---File Encrypted---");

        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    public void decryptFile(String name) throws IOException {
        ResourceBundle resourceBundle = new PropertyResourceBundle(new FileInputStream("/Users/eali/Projects/azure/myazurefunctionsdemo/src/main/resources/application.properties"));

        InputStream inputStreamSecretKey = new FileInputStream(resourceBundle.getString("gpg.keychain.secret.key"));
        InputStream inputStreamPublicKey = new FileInputStream(resourceBundle.getString("gpg.keychain.public.key"));
        char[] pass = {'n', 'i', 's', 'u', 'm', '1', '2', '3', '4'};

        // Writes data to the output stream
        OutputStream
                outbound = new FileOutputStream(resourceBundle.getString("encrypted.files.directory.path") + name.replaceFirst(".csv",".asc"));
        String inbound= resourceBundle.getString("files.directory.path") + name;

        try {
//            use it when using only public key
//            PGPPublicKey key = PGPUtils.readPublicKey(inputStream);

//            use it to get secret key when using public + private key
//            PGPSecretKey pgpSecretKey = PGPUtils.readSecretKey(inputStream);

//                for decryption
            InputStream fileToBeDecrypt = new FileInputStream(resourceBundle.getString
                    ("encrypted.files.directory.path") + name.replaceFirst(".csv", ".asc"));
            OutputStream inboundN = new FileOutputStream(resourceBundle.getString("decrypted.files.directory.path"));
            PGPUtils.decryptFile(fileToBeDecrypt, inboundN, inputStreamSecretKey, pass, inputStreamPublicKey);
            logger.info("---File Decrypted---");

        } catch (Exception e) {
            e.printStackTrace();
        }

    }

}
